use strict;

use Win32::Serialport;

$| = 1;

my $Port;

if ($Port = new Win32::SerialPort('COM3')
	and	$Port->baudrate(38400)
	and $Port->parity('none')
	and $Port->databits(8)
	and $Port->stopbits(2)
	and $Port->handshake('none')
	and $Port->buffers(4096,4096)
	and $Port->binary(1)
	and $Port->datatype('raw')
	and $Port->dtr_active('N')
	and $Port->write_settings)
{
	print "Connected.\n";
	$Port->pulse_dtr_on(10);
	sleep 3;
	$Port->input;
} else {
	die "Can't connect.\n"
}

foreach (0 .. 10000) {
	my $rnd = rnd();
	my $str = '';
	print "$rnd: ";
	$Port->write($rnd . "\r");
	$str .= $Port->input until $str =~ m/\r$/;
	$str =~ s/\r//g;
	print "$str  ";
	my $put = substr($str, 25);
	die "$rnd => $put" if $rnd != $put;
	my $pyr = substr($str, 11, 4);
	my $pmo = substr($str, 7, 3);
	my $pda = substr($str, 4, 2);
	my $phr = substr($str, 16, 2);
	my $pmn = substr($str, 19, 2);
	my $pse = substr($str, 22, 2);
	my $pwd = substr($str, 0, 3);
	my $stu = gmtime($rnd);
	print "$stu\n";
	die "$rnd: $str  Year [$pyr]" if $pyr != substr($stu, 20, 4);
	die "$rnd: $str  Mon  [$pmo]" if $pmo ne substr($stu,  4, 3);
	die "$rnd: $str  Day  [$pda]" if $pda != substr($stu,  8, 2);
	die "$rnd: $str  Hour [$phr]" if $phr != substr($stu, 11, 2);
	die "$rnd: $str  Min  [$pmn]" if $pmn != substr($stu, 14, 2);
	die "$rnd: $str  Sec  [$pse]" if $pse != substr($stu, 17, 2);
	die "$rnd: $str  Wkdy [$pwd]" if $pwd ne substr($stu,  0, 3);
	
}

sub rnd {
	my $val = rand(0x7fff) << 16 | rand(0xffff);
	return $val
}